/**
* @brief
websocketʱ߳

* @version
  V 1.0.0

* @author
  濡

* @date
  ʱ:  2018-08-17\n

* @note
  2018-08-17  ࡣ\n

* @warning

* @bug
  
*/

#pragma once

#include <boost/thread.hpp>
#include <boost/bind.hpp>
#include <boost/atomic.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/thread/condition.hpp>
#include <boost/serialization/singleton.hpp>

#include "thread_safe_map.h"
#include "ws_common.h"

namespace YA
{
	class wsTimerThread
	{
	private:
		boost::shared_ptr<boost::thread> __Thread;//߳
		boost::atomic<bool> __Enable;//߳Ƿеı־
		boost::atomic<bool> __Running;//߳Ƿеı־
		boost::condition_variable_any __ExitCond;//
		boost::mutex __ExitMutex;//(__ExitCond)
		_THREAD_CONFIG_ __Config;//߳
		thread_safe_map<int, _CARD_POS_> __CardPosList;//λб
	private:
		/**
		* @brief
		  ú

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void __Reset();
		/**
		* @brief
		  ߳ǷϷ

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void __ChkConfig();
	protected:
		/**
		* @brief
		  ̺߳

		* @param  [in] wsTimerThread* pOwner  ߳\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _ThreadFunc( wsTimerThread* pOwner );
	public:
		wsTimerThread();
		~wsTimerThread();
		/**
		* @brief
		  ̺߳

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void Start();
		/**
		* @brief
		  ֹ̺ͣ߳

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void Stop();
		/**
		* @brief
		  ʼ

		* @param  [in] const _THREAD_CONFIG_& Config  ߳\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void Init( const _THREAD_CONFIG_& Config );
		/**
		* @brief
		  ӿλú

		* @param  [in] const _CARD_POS_& pos  λýṹ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void add_card_pos( const _CARD_POS_& pos );
		/**
		* @brief
		  ¿λú

		* @param  [in] const _CARD_POS_& pos  λýṹ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void upt_card_pos( const _CARD_POS_& pos );
		/**
		* @brief
		  ɾλú

		* @param  [in] const _CARD_POS_& pos  λýṹ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void del_card_pos( const _CARD_POS_& pos );
	};
}

//
typedef boost::serialization::singleton<YA::wsTimerThread> singleton_wsTimerThread;
#define swsTimerThrd singleton_wsTimerThread::get_mutable_instance()
#define swsTimerThrd_const singleton_wsTimerThread::get_const_instance()